/* This file is is generated by a shell script.  DO NOT EDIT! */

/* Emulate the original gld for the given msp430elf
   Copyright (C) 2014-2015 Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com
   Extended for the MSP430 by Nick Clifton  nickc@redhat.com
   
   This file is part of the GNU Binutils.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston,
   MA 02110-1301, USA.  */

#define TARGET_IS_msp430elf

#include "sysdep.h"
#include "bfd.h"
#include "bfdlink.h"

#include "ld.h"
#include "getopt.h"
#include "ldmain.h"
#include "ldmisc.h"
#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"
#include "libiberty.h"
#include <ldgram.h>

enum regions
{
  REGION_NONE = 0,
  REGION_LOWER,
  REGION_UPPER,
  REGION_EITHER = 3,
};

enum either_placement_stage
{
  LOWER_TO_UPPER,
  UPPER_TO_LOWER,
};

enum { ROM, RAM };

static int data_region = REGION_NONE;
static int code_region = REGION_NONE;
static bfd_boolean disable_sec_transformation = FALSE;
static bfd_boolean lto_really_active = FALSE;

#define MAX_PREFIX_LENGTH 7

#include "elf-bfd.h"


static void
gldmsp430elf_map_segments (bfd_boolean need_layout)
{
  int tries = 10;

  do
    {
      lang_relax_sections (need_layout);
      need_layout = FALSE;

      if (link_info.output_bfd->xvec->flavour == bfd_target_elf_flavour
	  && !bfd_link_relocatable (&link_info))
	{
	  bfd_size_type phdr_size;

	  phdr_size = elf_program_header_size (link_info.output_bfd);
	  /* If we don't have user supplied phdrs, throw away any
	     previous linker generated program headers.  */
	  if (lang_phdr_list == NULL)
	    elf_seg_map (link_info.output_bfd) = NULL;
	  if (!_bfd_elf_map_sections_to_segments (link_info.output_bfd,
						  &link_info))
	    einfo ("%F%P: map sections to segments failed: %E\n");

	  if (phdr_size != elf_program_header_size (link_info.output_bfd))
	    {
	      if (tries > 6)
		/* The first few times we allow any change to
		   phdr_size .  */
		need_layout = TRUE;
	      else if (phdr_size
		       < elf_program_header_size (link_info.output_bfd))
		/* After that we only allow the size to grow.  */
		need_layout = TRUE;
	      else
		elf_program_header_size (link_info.output_bfd) = phdr_size;
	    }
	}
    }
  while (need_layout && --tries);

  if (tries == 0)
    einfo (_("%P%F: looping in map_segments"));
}

static void
gldmsp430elf_after_open (void)
{
  bfd *ibfd;
  asection *sec;
  asymbol **syms;

  after_open_default ();

  if (bfd_link_relocatable (&link_info))
    for (ibfd = link_info.input_bfds; ibfd != NULL; ibfd = ibfd->link.next)
      if ((syms = bfd_get_outsymbols (ibfd)) != NULL
	  && bfd_get_flavour (ibfd) == bfd_target_elf_flavour)
	for (sec = ibfd->sections; sec != NULL; sec = sec->next)
	  if ((sec->flags & (SEC_GROUP | SEC_LINKER_CREATED)) == SEC_GROUP)
	    {
	      struct bfd_elf_section_data *sec_data = elf_section_data (sec);
	      elf_group_id (sec) = syms[sec_data->this_hdr.sh_info - 1];
	    }
}

static void
gldmsp430elf_before_allocation (void)
{
  if (bfd_link_relocatable (&link_info)
      && !_bfd_elf_size_group_sections (&link_info))
    einfo ("%X%P: can not size group sections: %E\n");
  before_allocation_default ();
}

static void
gldmsp430elf_after_allocation (void)
{
  gldmsp430elf_map_segments (FALSE);
}

static void
gldmsp430elf_before_parse (void)
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_set_output_arch ("msp:14", bfd_arch_unknown);
#endif /* not TARGET_ */

  /* The MSP430 port *needs* linker relaxtion in order to cope with large
     functions where conditional branches do not fit into a +/- 1024 byte range.  */
  if (!bfd_link_relocatable (&link_info))
    TARGET_ENABLE_RELAXATION;
}


static char *
gldmsp430elf_get_script (int *isfile)
{
  *isfile = 0;

  if (bfd_link_relocatable (&link_info) && config.build_constructors)
    return
"/* Script for ld -Ur: link w/out relocation, do create constructors */\n\
/* Copyright (C) 2014-2015 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
MEMORY\n\
{\n\
  text   (rx)   	: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)  	: ORIGIN = 0x0500, 	LENGTH = 1K\n\
  vectors (rw)  	: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader 0 :\n\
  {\n\
    *(.bootloader)\n\
    *(.bootloader.*)\n\
  }\n\
  /* Information memory.  */\n"
"  .infomem 0 :\n\
  {\n\
    *(.infomem)\n\
    *(.infomem.*)\n\
  }\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits 0 :\n\
  {\n\
    *(.infomemnobits)\n\
    *(.infomemnobits.*)\n\
  }\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash        0 : { *(.hash)             }\n\
  .dynsym      0 : { *(.dynsym)           }\n\
  .dynstr      0 : { *(.dynstr)           }\n\
  .gnu.version 0 : { *(.gnu.version)      }\n\
  .gnu.version_d 0 : { *(.gnu.version_d)  }\n\
  .gnu.version_r 0 : { *(.gnu.version_r)  }\n\
  .rel.init    0 : { *(.rel.init) }\n\
  .rela.init   0 : { *(.rela.init) }\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n"
"    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.fini    0 : { *(.rel.fini) }\n\
  .rela.fini   0 : { *(.rela.fini) }\n\
  .rel.rodata  0 :\n\
    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n\
    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.ctors   0 : { *(.rel.ctors)        }\n\
  .rela.ctors  0 : { *(.rela.ctors)       }\n\
  .rel.dtors   0 : { *(.rel.dtors)        }\n\
  .rela.dtors  0 : { *(.rela.dtors)       }\n"
"  .rel.got     0 : { *(.rel.got)          }\n\
  .rela.got    0 : { *(.rela.got)         }\n\
  .rel.bss     0 : { *(.rel.bss)          }\n\
  .rela.bss    0 : { *(.rela.bss)         }\n\
  .rel.plt     0 : { *(.rel.plt)          }\n\
  .rela.plt    0 : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text :\n\
  {\n\
    *(SORT_NONE(.init))\n\
    *(SORT_NONE(.init0))  /* Start here after reset.  */\n\
    *(SORT_NONE(.init1))\n\
    *(SORT_NONE(.init2))  /* Copy data loop  */\n\
    *(SORT_NONE(.init3))\n\
    *(SORT_NONE(.init4))  /* Clear bss  */\n\
    *(SORT_NONE(.init5))\n\
    *(SORT_NONE(.init6))  /* C++ constructors.  */\n\
    *(SORT_NONE(.init7))\n\
    *(SORT_NONE(.init8))\n\
    *(SORT_NONE(.init9))  /* Call main().  */\n\
     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n"
"     __dtors_end = . ;\n\
    *(.lower.text.* .lower.text)\n\
    *(.text)\n\
    *(.text.*)\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    *(SORT_NONE(.fini9))\n\
    *(SORT_NONE(.fini8))\n\
    *(SORT_NONE(.fini7))\n\
    *(SORT_NONE(.fini6))  /* C++ destructors.  */\n\
    *(SORT_NONE(.fini5))\n\
    *(SORT_NONE(.fini4))\n\
    *(SORT_NONE(.fini3))\n\
    *(SORT_NONE(.fini2))\n\
    *(SORT_NONE(.fini1))\n\
    *(SORT_NONE(.fini0))  /* Infinite loop after program termination.  */\n\
    *(SORT_NONE(.fini))\n\
    _etext = .;\n\
  }\n\
  .rodata :\n\
  {\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }\n\
  .vectors 0:\n\
  {\n\
    *(.vectors*)\n\
  }\n\
  .data 0 :\n\
  {\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
  }\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  :\n\
  {\n\
    *(.lower.bss.* .lower.bss)\n\
    *(.bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
  }\n\
  .noinit  :\n\
  {\n\
    *(.noinit)\n\
  }\n\
  .persistent  :\n\
  {\n\
    *(.persistent)\n\
  }\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end ) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
  ; else if (bfd_link_relocatable (&link_info)) return
"/* Script for ld -r: link without relocation */\n\
/* Copyright (C) 2014-2015 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
MEMORY\n\
{\n\
  text   (rx)   	: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)  	: ORIGIN = 0x0500, 	LENGTH = 1K\n\
  vectors (rw)  	: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader 0 :\n\
  {\n\
    *(.bootloader)\n\
    *(.bootloader.*)\n\
  }\n\
  /* Information memory.  */\n"
"  .infomem 0 :\n\
  {\n\
    *(.infomem)\n\
    *(.infomem.*)\n\
  }\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits 0 :\n\
  {\n\
    *(.infomemnobits)\n\
    *(.infomemnobits.*)\n\
  }\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash        0 : { *(.hash)             }\n\
  .dynsym      0 : { *(.dynsym)           }\n\
  .dynstr      0 : { *(.dynstr)           }\n\
  .gnu.version 0 : { *(.gnu.version)      }\n\
  .gnu.version_d 0 : { *(.gnu.version_d)  }\n\
  .gnu.version_r 0 : { *(.gnu.version_r)  }\n\
  .rel.init    0 : { *(.rel.init) }\n\
  .rela.init   0 : { *(.rela.init) }\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n"
"    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.fini    0 : { *(.rel.fini) }\n\
  .rela.fini   0 : { *(.rela.fini) }\n\
  .rel.rodata  0 :\n\
    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n\
    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.ctors   0 : { *(.rel.ctors)        }\n\
  .rela.ctors  0 : { *(.rela.ctors)       }\n\
  .rel.dtors   0 : { *(.rel.dtors)        }\n\
  .rela.dtors  0 : { *(.rela.dtors)       }\n"
"  .rel.got     0 : { *(.rel.got)          }\n\
  .rela.got    0 : { *(.rela.got)         }\n\
  .rel.bss     0 : { *(.rel.bss)          }\n\
  .rela.bss    0 : { *(.rela.bss)         }\n\
  .rel.plt     0 : { *(.rel.plt)          }\n\
  .rela.plt    0 : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text :\n\
  {\n\
    *(SORT_NONE(.init))\n\
    *(SORT_NONE(.init0))  /* Start here after reset.  */\n\
    *(SORT_NONE(.init1))\n\
    *(SORT_NONE(.init2))  /* Copy data loop  */\n\
    *(SORT_NONE(.init3))\n\
    *(SORT_NONE(.init4))  /* Clear bss  */\n\
    *(SORT_NONE(.init5))\n\
    *(SORT_NONE(.init6))  /* C++ constructors.  */\n\
    *(SORT_NONE(.init7))\n\
    *(SORT_NONE(.init8))\n\
    *(SORT_NONE(.init9))  /* Call main().  */\n\
    *(.lower.text.* .lower.text)\n\
    *(.text)\n\
    *(.text.*)\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n"
"    *(.upper.text.* .upper.text)\n\
    *(SORT_NONE(.fini9))\n\
    *(SORT_NONE(.fini8))\n\
    *(SORT_NONE(.fini7))\n\
    *(SORT_NONE(.fini6))  /* C++ destructors.  */\n\
    *(SORT_NONE(.fini5))\n\
    *(SORT_NONE(.fini4))\n\
    *(SORT_NONE(.fini3))\n\
    *(SORT_NONE(.fini2))\n\
    *(SORT_NONE(.fini1))\n\
    *(SORT_NONE(.fini0))  /* Infinite loop after program termination.  */\n\
    *(SORT_NONE(.fini))\n\
    _etext = .;\n\
  }\n\
  .rodata :\n\
  {\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }\n\
  .vectors 0:\n\
  {\n\
    *(.vectors*)\n\
  }\n\
  .data 0 :\n\
  {\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
  }\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  :\n\
  {\n\
    *(.lower.bss.* .lower.bss)\n\
    *(.bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
  }\n\
  .noinit  :\n\
  {\n\
    *(.noinit)\n\
  }\n\
  .persistent  :\n\
  {\n\
    *(.persistent)\n\
  }\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end ) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N: mix text and data on same page; don't align data */\n\
/* Copyright (C) 2014-2015 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
MEMORY\n\
{\n\
  text   (rx)   	: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)  	: ORIGIN = 0x0500, 	LENGTH = 1K\n\
  vectors (rw)  	: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader   :\n\
  {\n\
     PROVIDE (__boot_start = .) ;\n\
    *(.bootloader)\n\
    . = ALIGN(2);\n\
    *(.bootloader.*)\n"
"  }  > bootloader\n\
  /* Information memory.  */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
    . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
    . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomemnobits\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          : { *(.hash)             }\n\
  .dynsym        : { *(.dynsym)           }\n\
  .dynstr        : { *(.dynstr)           }\n\
  .gnu.version   : { *(.gnu.version)      }\n\
  .gnu.version_d   : { *(.gnu.version_d)  }\n\
  .gnu.version_r   : { *(.gnu.version_r)  }\n\
  .rel.init      : { *(.rel.init) }\n\
  .rela.init     : { *(.rela.init) }\n\
  .rel.text      :\n"
"    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini) }\n\
  .rela.fini     : { *(.rela.fini) }\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n"
"  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)        }\n\
  .rela.ctors    : { *(.rela.ctors)       }\n\
  .rel.dtors     : { *(.rel.dtors)        }\n\
  .rela.dtors    : { *(.rela.dtors)       }\n\
  .rel.got       : { *(.rel.got)          }\n\
  .rela.got      : { *(.rela.got)         }\n\
  .rel.bss       : { *(.rel.bss)          }\n\
  .rela.bss      : { *(.rela.bss)         }\n\
  .rel.plt       : { *(.rel.plt)          }\n\
  .rela.plt      : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text :\n\
  {\n"
"    . = ALIGN(2);\n\
    *(SORT_NONE(.init))\n\
    *(SORT_NONE(.init0))  /* Start here after reset.  */\n\
    *(SORT_NONE(.init1))\n\
    *(SORT_NONE(.init2))  /* Copy data loop  */\n\
    *(SORT_NONE(.init3))\n\
    *(SORT_NONE(.init4))  /* Clear bss  */\n\
    *(SORT_NONE(.init5))\n\
    *(SORT_NONE(.init6))  /* C++ constructors.  */\n\
    *(SORT_NONE(.init7))\n\
    *(SORT_NONE(.init8))\n\
    *(SORT_NONE(.init9))  /* Call main().  */\n\
     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    . = ALIGN(2);\n\
    *(.lower.text.* .lower.text)\n\
    . = ALIGN(2);\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    . = ALIGN(2);\n\
    *(SORT_NONE(.fini9))\n\
    *(SORT_NONE(.fini8))\n\
    *(SORT_NONE(.fini7))\n\
    *(SORT_NONE(.fini6))  /* C++ destructors.  */\n\
    *(SORT_NONE(.fini5))\n\
    *(SORT_NONE(.fini4))\n\
    *(SORT_NONE(.fini3))\n\
    *(SORT_NONE(.fini2))\n\
    *(SORT_NONE(.fini1))\n\
    *(SORT_NONE(.fini0))  /* Infinite loop after program termination.  */\n\
    *(SORT_NONE(.fini))\n\
    _etext = .;\n\
  }  > text\n\
  .rodata :\n\
  {\n\
    . = ALIGN(2);\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }  > text\n\
  .vectors  :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    *(.vectors*)\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .data   :\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
     PROVIDE (__datastart = .) ;\n\
    . = ALIGN(2);\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    . = ALIGN(2);\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    . = ALIGN(2);\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
    . = ALIGN(2);\n\
     _edata = . ;\n\
  }  > data AT> text\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    . = ALIGN(2);\n\
     PROVIDE (__bss_start = .);\n\
     PROVIDE (__bssstart = .);\n\
    *(.lower.bss.* .lower.bss)\n\
    . = ALIGN(2);\n\
    *(.bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > data\n\
   PROVIDE (__bsssize = SIZEOF(.bss));\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit)\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > data\n\
  .persistent  SIZEOF(.noinit) + ADDR(.noinit) :\n\
  {\n\
     PROVIDE (__persistent_start = .) ;\n\
    *(.persistent)\n\
     PROVIDE (__persistent_end = .) ;\n\
  }  > data\n\
   _end = . ;\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end ) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n: mix text and data on same page */\n\
/* Copyright (C) 2014-2015 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
MEMORY\n\
{\n\
  text   (rx)   	: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)  	: ORIGIN = 0x0500, 	LENGTH = 1K\n\
  vectors (rw)  	: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader   :\n\
  {\n\
     PROVIDE (__boot_start = .) ;\n\
    *(.bootloader)\n\
    . = ALIGN(2);\n\
    *(.bootloader.*)\n"
"  }  > bootloader\n\
  /* Information memory.  */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
    . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
    . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomemnobits\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          : { *(.hash)             }\n\
  .dynsym        : { *(.dynsym)           }\n\
  .dynstr        : { *(.dynstr)           }\n\
  .gnu.version   : { *(.gnu.version)      }\n\
  .gnu.version_d   : { *(.gnu.version_d)  }\n\
  .gnu.version_r   : { *(.gnu.version_r)  }\n\
  .rel.init      : { *(.rel.init) }\n\
  .rela.init     : { *(.rela.init) }\n\
  .rel.text      :\n"
"    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini) }\n\
  .rela.fini     : { *(.rela.fini) }\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n"
"  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)        }\n\
  .rela.ctors    : { *(.rela.ctors)       }\n\
  .rel.dtors     : { *(.rel.dtors)        }\n\
  .rela.dtors    : { *(.rela.dtors)       }\n\
  .rel.got       : { *(.rel.got)          }\n\
  .rela.got      : { *(.rela.got)         }\n\
  .rel.bss       : { *(.rel.bss)          }\n\
  .rela.bss      : { *(.rela.bss)         }\n\
  .rel.plt       : { *(.rel.plt)          }\n\
  .rela.plt      : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text :\n\
  {\n"
"    . = ALIGN(2);\n\
    *(SORT_NONE(.init))\n\
    *(SORT_NONE(.init0))  /* Start here after reset.  */\n\
    *(SORT_NONE(.init1))\n\
    *(SORT_NONE(.init2))  /* Copy data loop  */\n\
    *(SORT_NONE(.init3))\n\
    *(SORT_NONE(.init4))  /* Clear bss  */\n\
    *(SORT_NONE(.init5))\n\
    *(SORT_NONE(.init6))  /* C++ constructors.  */\n\
    *(SORT_NONE(.init7))\n\
    *(SORT_NONE(.init8))\n\
    *(SORT_NONE(.init9))  /* Call main().  */\n\
     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    . = ALIGN(2);\n\
    *(.lower.text.* .lower.text)\n\
    . = ALIGN(2);\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    . = ALIGN(2);\n\
    *(SORT_NONE(.fini9))\n\
    *(SORT_NONE(.fini8))\n\
    *(SORT_NONE(.fini7))\n\
    *(SORT_NONE(.fini6))  /* C++ destructors.  */\n\
    *(SORT_NONE(.fini5))\n\
    *(SORT_NONE(.fini4))\n\
    *(SORT_NONE(.fini3))\n\
    *(SORT_NONE(.fini2))\n\
    *(SORT_NONE(.fini1))\n\
    *(SORT_NONE(.fini0))  /* Infinite loop after program termination.  */\n\
    *(SORT_NONE(.fini))\n\
    _etext = .;\n\
  }  > text\n\
  .rodata :\n\
  {\n\
    . = ALIGN(2);\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }  > text\n\
  .vectors  :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    *(.vectors*)\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .data   :\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
     PROVIDE (__datastart = .) ;\n\
    . = ALIGN(2);\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    . = ALIGN(2);\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    . = ALIGN(2);\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
    . = ALIGN(2);\n\
     _edata = . ;\n\
  }  > data AT> text\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    . = ALIGN(2);\n\
     PROVIDE (__bss_start = .);\n\
     PROVIDE (__bssstart = .);\n\
    *(.lower.bss.* .lower.bss)\n\
    . = ALIGN(2);\n\
    *(.bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > data\n\
   PROVIDE (__bsssize = SIZEOF(.bss));\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit)\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > data\n\
  .persistent  SIZEOF(.noinit) + ADDR(.noinit) :\n\
  {\n\
     PROVIDE (__persistent_start = .) ;\n\
    *(.persistent)\n\
     PROVIDE (__persistent_end = .) ;\n\
  }  > data\n\
   _end = . ;\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end ) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
/* Copyright (C) 2014-2015 Free Software Foundation, Inc.\n\
   Copying and distribution of this script, with or without modification,\n\
   are permitted in any medium without royalty provided the copyright\n\
   notice and this notice are preserved.  */\n\
OUTPUT_FORMAT(\"elf32-msp430\",\"elf32-msp430\",\"elf32-msp430\")\n\
OUTPUT_ARCH(msp:14)\n\
MEMORY\n\
{\n\
  text   (rx)   	: ORIGIN = 0x8000,  LENGTH = 0x7fe0\n\
  data   (rwx)  	: ORIGIN = 0x0500, 	LENGTH = 1K\n\
  vectors (rw)  	: ORIGIN = 0xffe0,      LENGTH = 0x20\n\
  bootloader(rx)	: ORIGIN = 0x0c00,	LENGTH = 1K\n\
  infomem(rx)		: ORIGIN = 0x1000,	LENGTH = 256\n\
  infomemnobits(rx)	: ORIGIN = 0x1000,      LENGTH = 256\n\
}\n\
SECTIONS\n\
{\n\
  /* Bootloader.  */\n\
  .bootloader   :\n\
  {\n\
     PROVIDE (__boot_start = .) ;\n\
    *(.bootloader)\n\
    . = ALIGN(2);\n\
    *(.bootloader.*)\n"
"  }  > bootloader\n\
  /* Information memory.  */\n\
  .infomem   :\n\
  {\n\
    *(.infomem)\n\
    . = ALIGN(2);\n\
    *(.infomem.*)\n\
  }  > infomem\n\
  /* Information memory (not loaded into MPU).  */\n\
  .infomemnobits   :\n\
  {\n\
    *(.infomemnobits)\n\
    . = ALIGN(2);\n\
    *(.infomemnobits.*)\n\
  }  > infomemnobits\n\
  /* Read-only sections, merged into text segment.  */\n\
  .hash          : { *(.hash)             }\n\
  .dynsym        : { *(.dynsym)           }\n\
  .dynstr        : { *(.dynstr)           }\n\
  .gnu.version   : { *(.gnu.version)      }\n\
  .gnu.version_d   : { *(.gnu.version_d)  }\n\
  .gnu.version_r   : { *(.gnu.version_r)  }\n\
  .rel.init      : { *(.rel.init) }\n\
  .rela.init     : { *(.rela.init) }\n\
  .rel.text      :\n"
"    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n\
    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini) }\n\
  .rela.fini     : { *(.rela.fini) }\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n"
"  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n\
      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)        }\n\
  .rela.ctors    : { *(.rela.ctors)       }\n\
  .rel.dtors     : { *(.rel.dtors)        }\n\
  .rela.dtors    : { *(.rela.dtors)       }\n\
  .rel.got       : { *(.rel.got)          }\n\
  .rela.got      : { *(.rela.got)         }\n\
  .rel.bss       : { *(.rel.bss)          }\n\
  .rela.bss      : { *(.rela.bss)         }\n\
  .rel.plt       : { *(.rel.plt)          }\n\
  .rela.plt      : { *(.rela.plt)         }\n\
  /* Internal text space.  */\n\
  .text :\n\
  {\n"
"    . = ALIGN(2);\n\
    *(SORT_NONE(.init))\n\
    *(SORT_NONE(.init0))  /* Start here after reset.  */\n\
    *(SORT_NONE(.init1))\n\
    *(SORT_NONE(.init2))  /* Copy data loop  */\n\
    *(SORT_NONE(.init3))\n\
    *(SORT_NONE(.init4))  /* Clear bss  */\n\
    *(SORT_NONE(.init5))\n\
    *(SORT_NONE(.init6))  /* C++ constructors.  */\n\
    *(SORT_NONE(.init7))\n\
    *(SORT_NONE(.init8))\n\
    *(SORT_NONE(.init9))  /* Call main().  */\n\
     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    . = ALIGN(2);\n\
    *(.lower.text.* .lower.text)\n\
    . = ALIGN(2);\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.text:*)\n\
    *(.either.text.* .either.text)\n\
    *(.upper.text.* .upper.text)\n\
    . = ALIGN(2);\n\
    *(SORT_NONE(.fini9))\n\
    *(SORT_NONE(.fini8))\n\
    *(SORT_NONE(.fini7))\n\
    *(SORT_NONE(.fini6))  /* C++ destructors.  */\n\
    *(SORT_NONE(.fini5))\n\
    *(SORT_NONE(.fini4))\n\
    *(SORT_NONE(.fini3))\n\
    *(SORT_NONE(.fini2))\n\
    *(SORT_NONE(.fini1))\n\
    *(SORT_NONE(.fini0))  /* Infinite loop after program termination.  */\n\
    *(SORT_NONE(.fini))\n\
    _etext = .;\n\
  }  > text\n\
  .rodata :\n\
  {\n\
    . = ALIGN(2);\n\
    *(.lower.rodata.* .lower.rodata)\n\
    . = ALIGN(2);\n\
    *(.plt)\n\
    *(.rodata .rodata.* .gnu.linkonce.r.* .const .const:*)\n\
    *(.rodata1)\n\
    *(.either.rodata.*) *(.either.rodata)\n\
    *(.upper.rodata.* .upper.rodata)\n\
    *(.eh_frame_hdr)\n\
    KEEP (*(.eh_frame))\n\
    KEEP (*(.gcc_except_table)) *(.gcc_except_table.*)\n\
    PROVIDE (__preinit_array_start = .);\n\
    KEEP (*(.preinit_array))\n\
    PROVIDE (__preinit_array_end = .);\n\
    PROVIDE (__init_array_start = .);\n\
    KEEP (*(SORT(.init_array.*)))\n\
    KEEP (*(.init_array))\n\
    PROVIDE (__init_array_end = .);\n\
    PROVIDE (__fini_array_start = .);\n\
    KEEP (*(.fini_array))\n\
    KEEP (*(SORT(.fini_array.*)))\n\
    PROVIDE (__fini_array_end = .);\n\
    /* gcc uses crtbegin.o to find the start of the constructors, so\n\
       we make sure it is first.  Because this is a wildcard, it\n\
       doesn't matter if the user does not actually link against\n\
       crtbegin.o; the linker won't look for a file to match a\n\
       wildcard.  The wildcard also means that it doesn't matter which\n\
       directory crtbegin.o is in.  */\n\
    KEEP (*crtbegin*.o(.ctors))\n\
    /* We don't want to include the .ctor section from from the\n\
       crtend.o file until after the sorted ctors.  The .ctor section\n\
       from the crtend file contains the end of ctors marker and it\n\
       must be last */\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))\n\
    KEEP (*(SORT(.ctors.*)))\n\
    KEEP (*(.ctors))\n\
    KEEP (*crtbegin*.o(.dtors))\n\
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))\n\
    KEEP (*(SORT(.dtors.*)))\n\
    KEEP (*(.dtors))\n\
  }  > text\n\
  .vectors  :\n\
  {\n\
     PROVIDE (__vectors_start = .) ;\n\
    *(.vectors*)\n\
     _vectors_end = . ;\n\
  }  > vectors\n\
  .data   :\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
     PROVIDE (__datastart = .) ;\n\
    . = ALIGN(2);\n\
    KEEP (*(.jcr))\n\
    *(.data.rel.ro.local) *(.data.rel.ro*)\n\
    *(.dynamic)\n\
    . = ALIGN(2);\n\
    *(.lower.data.* .lower.data)\n\
    *(.data)\n\
    *(.data.*)\n\
    *(.gnu.linkonce.d*)\n\
    KEEP (*(.gnu.linkonce.d.*personality*))\n\
    *(.data1)\n\
    *(.either.data.* .either.data)\n\
    *(.upper.data.* .upper.data)\n\
    *(.got.plt) *(.got)\n\
    . = ALIGN(2);\n\
    *(.sdata .sdata.* .gnu.linkonce.s.*)\n\
    . = ALIGN(2);\n\
     _edata = . ;\n\
  }  > data AT> text\n\
  __romdatastart = LOADADDR(.data);\n\
  __romdatacopysize = SIZEOF(.data);\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    . = ALIGN(2);\n\
     PROVIDE (__bss_start = .);\n\
     PROVIDE (__bssstart = .);\n\
    *(.lower.bss.* .lower.bss)\n\
    . = ALIGN(2);\n\
    *(.bss)\n\
    *(.either.bss.* .either.bss)\n\
    *(.upper.bss.* .upper.bss)\n\
    *(COMMON)\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > data\n\
   PROVIDE (__bsssize = SIZEOF(.bss));\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit)\n\
     PROVIDE (__noinit_end = .) ;\n\
  }  > data\n\
  .persistent  SIZEOF(.noinit) + ADDR(.noinit) :\n\
  {\n\
     PROVIDE (__persistent_start = .) ;\n\
    *(.persistent)\n\
     PROVIDE (__persistent_end = .) ;\n\
  }  > data\n\
   _end = . ;\n\
  /* Stabs for profiling information*/\n\
  .profiler 0 : { *(.profiler) }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line .debug_line.* .debug_line_end ) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
  /* SGI/MIPS DWARF 2 extensions */\n\
  .debug_weaknames 0 : { *(.debug_weaknames) }\n\
  .debug_funcnames 0 : { *(.debug_funcnames) }\n\
  .debug_typenames 0 : { *(.debug_typenames) }\n\
  .debug_varnames  0 : { *(.debug_varnames) }\n\
  /* DWARF 3 */\n\
  .debug_pubtypes 0 : { *(.debug_pubtypes) }\n\
  .debug_ranges   0 : { *(.debug_ranges) }\n\
  /* DWARF Extension.  */\n\
  .debug_macro    0 : { *(.debug_macro) }\n\
  .MSP430.attributes 0 :\n\
  {\n\
    KEEP (*(.MSP430.attributes))\n\
    KEEP (*(.gnu.attributes))\n\
    KEEP (*(__TI_build_attributes))\n\
  }\n\
  PROVIDE (__stack = 0x600) ;\n\
  PROVIDE (__data_start_rom = _etext) ;\n\
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;\n\
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;\n\
  PROVIDE (__subdevice_has_heap = 0) ;\n\
}\n\n"
; }

static unsigned int
data_statement_size (lang_data_statement_type *d)
{
  unsigned int size = 0;
  switch (d->type)
    {
    case QUAD:
    case SQUAD:
      size = QUAD_SIZE;
      break;
    case LONG:
      size = LONG_SIZE;
      break;
    case SHORT:
      size = SHORT_SIZE;
      break;
    case BYTE:
      size = BYTE_SIZE;
      break;
    default:
      einfo ("%P: error: unhandled data_statement size\n");
      FAIL ();
    }
  return size;
}

/* Helper function for place_orphan that computes the size
   of sections already mapped to the given statement.  */

static bfd_size_type
scan_children (lang_statement_union_type * l)
{
  bfd_size_type amount = 0;

  while (l != NULL)
    {
      switch (l->header.type)
	{
	case lang_input_section_enum:
	  if (l->input_section.section->flags & SEC_ALLOC)
	    amount += l->input_section.section->size;
	  break;

	case lang_constructors_statement_enum:
	case lang_assignment_statement_enum:
	case lang_padding_statement_enum:
	  break;

	case lang_wild_statement_enum:
	  amount += scan_children (l->wild_statement.children.head);	  
	  break;

	case lang_data_statement_enum:
	  amount += data_statement_size (&l->data_statement);
	  break;

	default:
	  fprintf (stderr, "msp430 orphan placer: unhandled lang type %d\n", l->header.type);
	  break;
	}

      l = l->header.next;
    }

  return amount;
}

#define WARN_UPPER 0
#define WARN_LOWER 1
#define WARN_TEXT 0
#define WARN_DATA 1
#define WARN_BSS 2
#define WARN_RODATA 3

/* Warn only once per output section.
 * NAME starts with ".upper." or ".lower.".  */
static void
warn_no_output_section(const char *name)
{
  static bfd_boolean warned[2][4] = {{FALSE, FALSE, FALSE, FALSE}, {FALSE, FALSE, FALSE, FALSE}};
  int i = WARN_LOWER;

  if (strncmp (name, ".upper.", 7) == 0)
    i = WARN_UPPER;

  if (!warned[i][WARN_TEXT] && strcmp (name + 6, ".text") == 0)
    warned[i][WARN_TEXT] = TRUE;
  else if (!warned[i][WARN_DATA] && strcmp (name + 6, ".data") == 0)
    warned[i][WARN_DATA] = TRUE;
  else if (!warned[i][WARN_BSS] && strcmp (name + 6, ".bss") == 0)
    warned[i][WARN_BSS] = TRUE;
  else if (!warned[i][WARN_RODATA] && strcmp (name + 6, ".rodata") == 0)
    warned[i][WARN_RODATA] = TRUE;
  else
    return;
  einfo ("%P: warning: no input section rule matches %s in linker script\n",
	 name);
}

  
/* Place an orphan section.  We use this to put .either sections
   into either their lower or their upper equivalents.  */

static lang_output_section_statement_type *
gldmsp430elf_place_orphan (asection * s,
				   const char * secname,
				   int constraint)
{
  char * lower_name;
  char * upper_name;
  char * name;
  lang_output_section_statement_type * lower;
  lang_output_section_statement_type * upper;

  if ((s->flags & SEC_ALLOC) == 0)
    return NULL;

  if (bfd_link_relocatable (&link_info))
    return NULL;

  /* If constraints are involved let the linker handle the placement normally.  */
  if (constraint != 0)
    return NULL;

  if (strncmp (secname, ".upper.", 7) == 0
      || strncmp (secname, ".lower.", 7) == 0)
    {
      warn_no_output_section (secname);
      return NULL;
    }

  /* We only need special handling for .either sections.  */
  if (strncmp (secname, ".either.", 8) != 0)
    return NULL;

  /* Skip the .either prefix.  */
  secname += 7;

  /* Compute the names of the corresponding upper and lower
     sections.  If the input section name contains another period,
     only use the part of the name before the second dot.  */
  if (strchr (secname + 1, '.') != NULL)
    {
      name = concat (secname, NULL);

      * strchr (name + 1, '.') = 0;
    }
  else
    name = (char *) secname;
  
  lower_name = concat (".lower", name, NULL);
  upper_name = concat (".upper", name, NULL);

  /* Find the corresponding lower and upper sections.  */
  lower = lang_output_section_find (lower_name);
  upper = lang_output_section_find (upper_name);

  if (lower == NULL && upper == NULL)
    {
      einfo ("%P: error: no section named %s or %s in linker script\n",
	     lower_name, upper_name);
      goto end;
    }
  else if (lower == NULL)
    {
      lower = lang_output_section_find (name);
      if (lower == NULL)
	{
	  einfo ("%P: error: no section named %s in linker script\n", name);
	  goto end;
	}
    }

  /* Always place orphaned sections in lower.  Optimal placement of either
     sections is performed later, once section sizes have been finalized.  */
  lang_add_section (& lower->children, s, NULL, lower);
 end:
  free (upper_name);
  free (lower_name);
  return lower;
}

static bfd_boolean
change_output_section (lang_statement_union_type ** head,
		       asection *s,
		       lang_output_section_statement_type * new_output_section)
{
  asection *is;
  lang_statement_union_type * prev = NULL;
  lang_statement_union_type * curr;

  curr = *head;
  while (curr != NULL)
    {
      switch (curr->header.type)
	{
	case lang_input_section_enum:
	  is = curr->input_section.section;
	  if (is == s)
	    {
	      s->output_section = NULL;
	      lang_add_section (& (new_output_section->children), s, NULL,
				new_output_section);
	      /* Remove the section from the old output section.  */
	      if (prev == NULL)
		*head = curr->header.next;
	      else
		prev->header.next = curr->header.next;
	      return TRUE;
	    }
	  break;
	case lang_wild_statement_enum:
	  if (change_output_section (&(curr->wild_statement.children.head),
				     s, new_output_section))
	    return TRUE;
	  break;
	default:
	  break;
	}
      prev = curr;
      curr = curr->header.next;
    }
  return FALSE;
}

static void
add_region_prefix (bfd *abfd, asection *s,
		   ATTRIBUTE_UNUSED void *unused)
{
  const char *curr_name = bfd_get_section_name (abfd, s);
  int region = REGION_NONE;

  if (strncmp (curr_name, ".text", 5) == 0)
    region = code_region;
  else if (strncmp (curr_name, ".data", 5) == 0)
    region = data_region;
  else if (strncmp (curr_name, ".bss", 4) == 0)
    region = data_region;
  else if (strncmp (curr_name, ".rodata", 7) == 0)
    region = data_region;
  else
    return;

  switch (region)
    {
    case REGION_NONE:
      break;
    case REGION_UPPER:
      bfd_rename_section (abfd, s, concat (".upper", curr_name, NULL));
      break;
    case REGION_LOWER:
      bfd_rename_section (abfd, s, concat (".lower", curr_name, NULL));
      break;
    case REGION_EITHER:
      s->name = concat (".either", curr_name, NULL);
      break;
    default:
      /* Unreachable.  */
      FAIL ();
      break;
    }
}

static void
msp430_elf_after_open (void)
{
  bfd *abfd;

  gldmsp430elf_after_open ();

  /* If neither --code-region or --data-region have been passed, do not
     transform sections names.  */
  if ((code_region == REGION_NONE && data_region == REGION_NONE)
      || disable_sec_transformation)
    return;

  for (abfd = link_info.input_bfds; abfd != NULL; abfd = abfd->link.next)
    bfd_map_over_sections (abfd, add_region_prefix, NULL);

}

static void
msp430_elf_after_parse (void)
{
  /* FIXME: gas can't intepret the LTO bytecode, so it doesn't know what
     sections are present in the file.  This means it can't work out which
     __crt0 symbols to define, based on the section names.
     As a work-around, add undefs for all the possible symbols gas could have
     defined.
     This adversely affects code size.
     link_info.lto_plugin_active is always true, even when the user has not
     passed enabled LTO by passing -flto to GCC.  The GCC specs for msp430
     will propagate -flto to the linker so we know if it's really in use and
     only define these symbols when necessary.  */
  if (lto_really_active)
    {
      ldlang_add_undef ("__crt0_run_preinit_array", FALSE);
      ldlang_add_undef ("__crt0_run_init_array", FALSE);
      ldlang_add_undef ("__crt0_run_fini_array", FALSE);
      ldlang_add_undef ("__crt0_run_array", FALSE);
      ldlang_add_undef ("__crt0_init_bss", FALSE);
      ldlang_add_undef ("__crt0_movedata", FALSE);
      /* Can we make a definite decision about if these are needed based on
         the code/data-region options?  */
      ldlang_add_undef ("__crt0_init_highbss", FALSE);
      ldlang_add_undef ("__crt0_move_highdata", FALSE);
    }

  after_parse_default ();
}

#define OPTION_CODE_REGION		321
#define OPTION_DATA_REGION		(OPTION_CODE_REGION + 1)
#define OPTION_DISABLE_TRANS		(OPTION_CODE_REGION + 2)
#define OPTION_LTO			(OPTION_CODE_REGION + 3)

static void
gldmsp430elf_add_options
  (int ns, char **shortopts, int nl, struct option **longopts,
   int nrl ATTRIBUTE_UNUSED, struct option **really_longopts ATTRIBUTE_UNUSED)
{
  static const char xtra_short[] = { };

  static const struct option xtra_long[] =
    {
      { "code-region", required_argument, NULL, OPTION_CODE_REGION },
      { "data-region", required_argument, NULL, OPTION_DATA_REGION },
      { "disable-sec-transformation", no_argument, NULL,
	OPTION_DISABLE_TRANS },
      { "lto-in-use", no_argument, NULL, OPTION_LTO },
      { NULL, no_argument, NULL, 0 }
    };

  *shortopts = (char *) xrealloc (*shortopts, ns + sizeof (xtra_short));
  memcpy (*shortopts + ns, &xtra_short, sizeof (xtra_short));
  *longopts = (struct option *)
    xrealloc (*longopts, nl * sizeof (struct option) + sizeof (xtra_long));
  memcpy (*longopts + nl, &xtra_long, sizeof (xtra_long));
}

static void
gldmsp430elf_list_options (FILE * file)
{
  fprintf (file, _("  --code-region={either,lower,upper,none}\n  \tTransform .text* sections to {either,lower,upper,none}.text* sections.\n  --data-region={either,lower,upper,none}\n  \tTransform .data*, .rodata* and .bss* sections to\n  {either,lower,upper,none}.{bss,data,rodata}* sections\n  --disable-sec-transformation\n  \tDisable transformation of .{text,data,bss,rodata}* sections to\n  \tadd the {either,lower,upper,none} prefixes\n"));
  /* --lto-in-use is purposefully omitted, it's not intended for direct use.  */
}

static bfd_boolean
gldmsp430elf_handle_option (int optc)
{
  switch (optc)
    {
    case OPTION_CODE_REGION:
      if (strcmp (optarg, "upper") == 0)
	code_region = REGION_UPPER;
      else if (strcmp (optarg, "lower") == 0)
	code_region = REGION_LOWER;
      else if (strcmp (optarg, "either") == 0)
	code_region = REGION_EITHER;
      else if (strcmp (optarg, "none") == 0)
	code_region = REGION_NONE;
      else if (strlen (optarg) == 0)
	{
	  einfo (_("%P: --code-region requires an argument: 		   {upper,lower,either,none}\n"));
	  return FALSE;
	}
      else
	{
	  einfo (_("%P: error: unrecognized argument to --code-region= option: 		   \"%s\"\n"), optarg);
	  return FALSE;
	}
      break;

    case OPTION_DATA_REGION:
      if (strcmp (optarg, "upper") == 0)
	data_region = REGION_UPPER;
      else if (strcmp (optarg, "lower") == 0)
	data_region = REGION_LOWER;
      else if (strcmp (optarg, "either") == 0)
	data_region = REGION_EITHER;
      else if (strcmp (optarg, "none") == 0)
	data_region = REGION_NONE;
      else if (strlen (optarg) == 0)
	{
	  einfo (_("%P: --data-region requires an argument: 		   {upper,lower,either,none}\n"));
	  return FALSE;
	}
      else
	{
	  einfo (_("%P: error: unrecognized argument to --data-region= option: 		   \"%s\"\n"), optarg);
	  return FALSE;
	}
      break;

    case OPTION_DISABLE_TRANS:
      disable_sec_transformation = TRUE;
      break;

    case OPTION_LTO:
      lto_really_active = TRUE;
      break;

    default:
      return FALSE;
    }
  return TRUE;
}

static void
eval_upper_either_sections (bfd *abfd, asection *s, void *data)
{
  const char * base_sec_name;
  const char * curr_name;
  char * either_name;
  int curr_region;

  lang_output_section_statement_type * lower;
  lang_output_section_statement_type * upper;
  static bfd_size_type *lower_size = 0;
  static bfd_size_type *upper_size = 0;
  static bfd_size_type lower_size_rom = 0;
  static bfd_size_type lower_size_ram = 0;
  static bfd_size_type upper_size_rom = 0;
  static bfd_size_type upper_size_ram = 0;

  if ((s->flags & SEC_ALLOC) == 0)
    return;
  if (bfd_link_relocatable (&link_info))
    return;

  base_sec_name = (const char *) data;
  curr_name = bfd_get_section_name (abfd, s);

  /* Only concerned with .either input sections in the upper output section.  */
  either_name = concat (".either", base_sec_name, NULL);
  if (strncmp (curr_name, either_name, strlen (either_name)) != 0
      || strncmp (s->output_section->name, ".upper", 6) != 0)
    goto end;

  lower = lang_output_section_find (concat (".lower", base_sec_name, NULL));
  upper = lang_output_section_find (concat (".upper", base_sec_name, NULL));

  if (upper == NULL || upper->region == NULL)
    goto end;
  else if (lower == NULL)
    lower = lang_output_section_find (base_sec_name);
  if (lower == NULL || lower->region == NULL)
    goto end;

  if (strcmp (base_sec_name, ".text") == 0
      || strcmp (base_sec_name, ".rodata") == 0)
    curr_region = ROM;
  else
    curr_region = RAM;

  if (curr_region == ROM)
    {
      if (lower_size_rom == 0)
	{
	  lower_size_rom = lower->region->current - lower->region->origin;
	  upper_size_rom = upper->region->current - upper->region->origin;
	}
      lower_size = &lower_size_rom;
      upper_size = &upper_size_rom;
    }
  else if (curr_region == RAM)
    {
      if (lower_size_ram == 0)
	{
	  lower_size_ram = lower->region->current - lower->region->origin;
	  upper_size_ram = upper->region->current - upper->region->origin;
	}
      lower_size = &lower_size_ram;
      upper_size = &upper_size_ram;
    }

  /* Move sections in the upper region that would fit in the lower
     region to the lower region.  */
  if (*upper_size > upper->region->length
      && *lower_size + s->size < lower->region->length)
    {
      if (change_output_section (&(upper->children.head), s, lower))
	{
	  *upper_size -= s->size;
	  *lower_size += s->size;
	}
    }
 end:
  free (either_name);
}

static void
eval_lower_either_sections (bfd *abfd, asection *s, void *data)
{
  const char * base_sec_name;
  const char * curr_name;
  char * either_name;
  int curr_region;
  lang_output_section_statement_type * output_sec;
  lang_output_section_statement_type * lower;
  lang_output_section_statement_type * upper;

  static bfd_size_type *lower_size = 0;
  static bfd_size_type lower_size_rom = 0;
  static bfd_size_type lower_size_ram = 0;

  if ((s->flags & SEC_ALLOC) == 0)
    return;
  if (bfd_link_relocatable (&link_info))
    return;

  base_sec_name = (const char *) data;
  curr_name = bfd_get_section_name (abfd, s);

  /* Only concerned with .either input sections in the lower or "default"
     output section i.e. not in the upper output section.  */
  either_name = concat (".either", base_sec_name, NULL);
  if (strncmp (curr_name, either_name, strlen (either_name)) != 0
      || strncmp (s->output_section->name, ".upper", 6) == 0)
    return;

  if (strcmp (base_sec_name, ".text") == 0
      || strcmp (base_sec_name, ".rodata") == 0)
    curr_region = ROM;
  else
    curr_region = RAM;

  output_sec = lang_output_section_find (s->output_section->name);

  /* If the output_section doesn't exist, this has already been reported in
     place_orphan, so don't need to warn again.  */
  if (output_sec == NULL || output_sec->region == NULL)
    goto end;

  /* lower and output_sec might be the same, but in some cases an .either
     section can end up in base_sec_name if it hasn't been placed by
     place_orphan.  */
  lower = lang_output_section_find (concat (".lower", base_sec_name, NULL));
  upper = lang_output_section_find (concat (".upper", base_sec_name, NULL));
  if (upper == NULL)
    goto end;

  if (curr_region == ROM)
    {
      if (lower_size_rom == 0)
	{
	  /* Get the size of other items in the lower region that aren't the
	     sections to be moved around.  */
	  lower_size_rom
	    = (output_sec->region->current - output_sec->region->origin)
	    - scan_children (output_sec->children.head);
	  if (output_sec != lower && lower != NULL)
	    lower_size_rom -= scan_children (lower->children.head);
	}
      lower_size = &lower_size_rom;
    }
  else if (curr_region == RAM)
    {
      if (lower_size_ram == 0)
	{
	  lower_size_ram
	    = (output_sec->region->current - output_sec->region->origin)
	    - scan_children (output_sec->children.head);
	  if (output_sec != lower && lower != NULL)
	    lower_size_ram -= scan_children (lower->children.head);
	}
      lower_size = &lower_size_ram;
    }
  /* Move sections that cause the lower region to overflow to the upper region.  */
  if (*lower_size + s->size > output_sec->region->length)
    change_output_section (&(output_sec->children.head), s, upper);
  else
    *lower_size += s->size;
 end:
  free (either_name);
}

/* This function is similar to lang_relax_sections, but without the size
   evaluation code that is always executed after relaxation.  */
static void
intermediate_relax_sections (void)
{
  int i = link_info.relax_pass;

  /* The backend can use it to determine the current pass.  */
  link_info.relax_pass = 0;

  while (i--)
    {
      bfd_boolean relax_again;

      link_info.relax_trip = -1;
      do
	{
	  link_info.relax_trip++;

	  lang_do_assignments (lang_assigning_phase_enum);

	  lang_reset_memory_regions ();

	  relax_again = FALSE;
	  lang_size_sections (&relax_again, FALSE);
	}
      while (relax_again);

      link_info.relax_pass++;
    }
}

static void
msp430_elf_after_allocation (void)
{
  int relax_count = 0;
  unsigned int i;
  /* Go over each section twice, once to place either sections that don't fit
     in lower into upper, and then again to move any sections in upper that
     fit in lower into lower.  */
  for (i = 0; i < 8; i++)
    {
      int placement_stage = (i < 4) ? LOWER_TO_UPPER : UPPER_TO_LOWER;
      const char * base_sec_name;
      lang_output_section_statement_type * upper;

      switch (i % 4)
	{
	default:
	case 0:
	  base_sec_name = ".text";
	  break;
	case 1:
	  base_sec_name = ".data";
	  break;
	case 2:
	  base_sec_name = ".bss";
	  break;
	case 3:
	  base_sec_name = ".rodata";
	  break;
	}
      upper = lang_output_section_find (concat (".upper", base_sec_name, NULL));
      if (upper != NULL)
	{
	  /* Can't just use one iteration over the all the sections to make
	     both lower->upper and upper->lower transformations because the
	     iterator encounters upper sections before all lower sections have
	     been examined.  */
	  bfd *abfd;

	  if (placement_stage == LOWER_TO_UPPER)
	    {
	      /* Perform relaxation and get the final size of sections
		 before trying to fit .either sections in the correct
		 ouput sections.  */
	      if (relax_count == 0)
		{
		  intermediate_relax_sections ();
		  relax_count++;
		}
	      for (abfd = link_info.input_bfds; abfd != NULL;
		   abfd = abfd->link.next)
		{
		  bfd_map_over_sections (abfd, eval_lower_either_sections,
					 (void *) base_sec_name);
		}
	    }
	  else if (placement_stage == UPPER_TO_LOWER)
	    {
	      /* Relax again before moving upper->lower.  */
	      if (relax_count == 1)
		{
		  intermediate_relax_sections ();
		  relax_count++;
		}
	      for (abfd = link_info.input_bfds; abfd != NULL;
		   abfd = abfd->link.next)
		{
		  bfd_map_over_sections (abfd, eval_upper_either_sections,
					 (void *) base_sec_name);
		}
	    }

	}
    }
  gldmsp430elf_after_allocation ();
}

/* Return TRUE if a non-debug input section with positive size matches the
   given name.  */
static int
input_section_exists (lang_statement_union_type * l, const char * name)
{
  while (l != NULL)
    {
      switch (l->header.type)
	{
	case lang_input_section_enum:
	  if ((l->input_section.section->flags & SEC_ALLOC)
	      && l->input_section.section->size > 0
	      && !strcmp (l->input_section.section->name, name))
	    return TRUE;
	  break;

	case lang_wild_statement_enum:
	  if (input_section_exists (l->wild_statement.children.head, name))
	    return TRUE;
	  break;

	default:
	  break;
	}
      l = l->header.next;
    }
  return FALSE;
}

static void
gldmsp430elf_finish (void)
{
  struct bfd_link_hash_entry * sym;

  finish_default ();

  /* .{preinit,init,fini}_array might be in .rodata or .rodata2.  */
  lang_output_section_statement_type * rodata_sec;
  lang_output_section_statement_type * rodata2_sec;
  rodata_sec = lang_output_section_find (".rodata");
  rodata2_sec = lang_output_section_find (".rodata2");
  if (rodata_sec == NULL && rodata2_sec == NULL)
    return;

  /* Pre-2019 MSP430 linker scripts distributed by TI do not include ALIGN
     directives to ensure __preinit_array_start, __init_array_start or
     __fini_array_start are word aligned.
     __init_array_start is really the only one that matters, since
     .preinit_array is unlikely to contain anything, and .fini_array is not
     likely to get run at all.
     If __init_array_start is not word aligned, the code to run through the
     array and call the constructors will crash.  */
  if (((rodata_sec && input_section_exists (rodata_sec->children.head,
					   ".init_array"))
       || (rodata2_sec && input_section_exists (rodata2_sec->children.head,
					       ".init_array")))
      && (sym = bfd_link_hash_lookup (link_info.hash, "__init_array_start",
				      FALSE, FALSE, TRUE))
      && sym->type == bfd_link_hash_defined
      && sym->u.def.value % 2)
    {
      einfo ("%P: warning: \"__init_array_start\" symbol (%U) "
	     "is not word aligned\n", NULL);
    }
  if (((rodata_sec && input_section_exists (rodata_sec->children.head,
					   ".preinit_array"))
       || (rodata2_sec && input_section_exists (rodata2_sec->children.head,
					       ".preinit_array")))
      && (sym = bfd_link_hash_lookup (link_info.hash, "__preinit_array_start",
				      FALSE, FALSE, TRUE))
      && sym->type == bfd_link_hash_defined
      && sym->u.def.value % 2)
    {
      einfo ("%P: warning: \"__preinit_array_start\" symbol (%U) "
	     "is not word aligned\n", NULL);
    }
  if (((rodata_sec && input_section_exists (rodata_sec->children.head,
					   ".fini_array"))
       || (rodata2_sec && input_section_exists (rodata2_sec->children.head,
					       ".fini_array")))
      && (sym = bfd_link_hash_lookup (link_info.hash, "__fini_array_start",
				      FALSE, FALSE, TRUE))
      && sym->type == bfd_link_hash_defined
      && sym->u.def.value % 2)
    {
      einfo ("%P: warning: \"__fini_array_start\" symbol (%U) "
	     "is not word aligned\n", NULL);
    }
}

struct ld_emulation_xfer_struct ld_msp430elf_emulation =
{
  gldmsp430elf_before_parse,
  syslib_default,
  hll_default,
  msp430_elf_after_parse,
  msp430_elf_after_open,
  msp430_elf_after_allocation,
  set_output_arch_default,
  ldemul_default_target,
  gldmsp430elf_before_allocation,
  gldmsp430elf_get_script,
  "msp430elf",
  "elf32-msp430",
  gldmsp430elf_finish,
  NULL,
  NULL,
  gldmsp430elf_place_orphan,
  NULL,
  NULL,
  gldmsp430elf_add_options,
  gldmsp430elf_handle_option,
  NULL,
  gldmsp430elf_list_options,
  NULL,
  NULL,
  NULL,
  NULL
};
